package TermExtract::BrillsTagger;
use TermExtract::Calc_Imp;

use strict;
use Exporter ();
use vars qw(@ISA $VERSION @EXPORT);
use locale;

@ISA = qw(TermExtract::Calc_Imp Exporter);
@EXPORT = qw();
$VERSION = "2.01";

# ========================================================================
# get_noun_frq -- Get noun frequency.
#                 The values of the hash are frequency of the noun.
# ѸȤ٤륵֥롼
#
#  Over-write TermExtract::Calc_Imp::get_noun_frq
#
# ========================================================================

sub get_noun_frq {
    my $self = shift;
    my $data = shift;           # ϥǡ
    my $mode = shift || 0;      # ϥǡե뤫ѿμѥե饰
    my %cmp_noun_list = ();     # ʣپ줿ϥåʴؿ͡

    $self->IgnoreWords('of', 'Of', 'OF');  # of Ͻٷ׻Ȥ

    # Ϥեξ
    if ($mode ne 'var') {
        local($/) = undef;
        open (IN, $data) || die "Can not open input file. $!";
        $data = <IN>;
        close IN;
    }

    foreach my $morph ((split /\n/, $data)) {
        chomp $morph;
        next if $morph =~ /^\s*$/;

        # $status = 1   ̾(NN, NNS, NNP)
        #           2   ƻ(JJ)
        #           3   ͭʸ(POS)
        #           4   of
        #           5   (CD)
        #           6   ʬư(VBN)
        #           7   (FW)
        my $status = 0;

        my $rest   = 0;  # ̾ʳθ줬Ϣ³
        my @seg    = (); # ʣΥꥹȡ

        foreach my $term (split(/ /, $morph)) {
            # ͤڤ국ξ
            if($term =~ /^[\s\+\-\%\&\$\*\#\^\|\/]/ || $term =~ /^[\d]+\//){
                _increase_frq(\%cmp_noun_list, \@seg, \$rest);
                next;
            }
            next if $term =~ /suusiki/;  # Ͻ

            # ̾ξ
            if($term =~ /NN[PS]?$/ || $term =~ /NNPS$/){
                # ʣñ֤롣
                $term = &_stemming($term) if $term =~ /NNS$/;
                # ͭ̾ʳƬʸʸˡ
                $term = lcfirst($term) if ($term =~ /NNS?$/ && $term =~ /^[A-Z][a-z]/);
                $status = 1;
                push(@seg, $term); $rest = 0;
            }
            # ƻ(JJ)ξ
            elsif($term =~ /JJ$/){
                #θ줬"ʤ","ƻ","ͭʸ",""ξϢ뤹
                if($status == 0 || $status == 2 || $status == 3 || $status == 5){
                    push(@seg, $term); $rest++;
                }
                else {
                    _increase_frq(\%cmp_noun_list, \@seg, \$rest);
                    @seg = ($term); $rest++;
                }
                $status = 2;
           }
            # ͭʸ(POS)ξ
            elsif($term =~ /POS$/){
               # θ줬̾ξϢ뤹
               if($status == 1){
                    $status = 3;
                    push(@seg, $term); $rest++;
                }
                else{
                    _increase_frq(\%cmp_noun_list, \@seg);
                }
            }
            # of ξ
            elsif($term =~ /^of\/IN$/){
                # θ줬̾ξϢ뤹
                if($status == 1){
                    $status = 4;
                    push(@seg, $term); $rest++;
                }
                else{
                    _increase_frq(\%cmp_noun_list, \@seg, \$rest);
                    $status = 0;
		}
            }
            # (CD)ξϡƬΤߵ
            elsif($term =~ /CD$/){
                _increase_frq(\%cmp_noun_list, \@seg, \$rest);
                @seg = ($term);
                $status = 5;
            }
            # ʬưϸƬΤߵ
            elsif($term =~ /VBN$/){
                _increase_frq(\%cmp_noun_list, \@seg, \$rest);
                $status = 6;
                @seg = ($term); $rest++;
            }
            # (FW)ξñȤƽ
            elsif($term =~ /FW$/){
                _increase_frq(\%cmp_noun_list, \@seg, \$rest);
                $status = 7;
                @seg = ($term);
                _increase_frq(\%cmp_noun_list, \@seg, \$rest);
            }
            # ꤷʻʳξϡʣζڤȤ
            else{
                _increase_frq(\%cmp_noun_list, \@seg, \$rest);
                $status = 0;
            }
        }
        # ԤäϤʣζڤȤ
        _increase_frq(\%cmp_noun_list, \@seg, \$rest);
        $status = 0;
    }
    return \%cmp_noun_list;
}

# ---------------------------------------------------------------------------
#   _stemming  --  ʣñѤstemmer
# 
#   usage : _stemming(word);
# ---------------------------------------------------------------------------

sub _stemming {
    my $noun = shift;

    if($noun =~ /ies\// && $noun !~ /[ae]ies\//){
	$noun =~ s/ies\//y\//;
    }
    elsif($noun =~ /es\// && $noun !~ /[aeo]es\//){
	$noun =~ s/es\//e\//;
    }
    elsif($noun =~ /s\// && $noun !~ /[us]s\//){
	$noun =~ s/s\//\//;
    }
    $noun;
}

# ---------------------------------------------------------------------------
#   _increase_frq  --  䤹
# 
#   usage : _increase_frq(array_ref, array);
# ---------------------------------------------------------------------------

sub _increase_frq {
    my $frq_ref  = shift;
    my $seg      = shift;
    my $rest     = shift;
    my $allwords = "";

    # ʣ̾ȤʳڤΤƤ
    $#$seg -= $$rest if @$seg;
    $$rest = 0;

    if ($#$seg >= 0) {
        foreach my $word (@$seg) {
            $word =~ s/^\s+//;        # ʥڡ
            $word =~ s/\s+$//;
	    $word =~ s/\/[A-Z\$]+$//; # 
            if ($allwords eq "") { 
                $allwords = $word;
            }
            else {
                $allwords .= ' ' . $word;
            }
        }
        # ' Ƕڤ줿³
        $allwords =~ s/(\S+)\s(\'s\s)/$1$2/g;
        #  .  , Ϻ
        $allwords =~ s/\,$//;
        $allwords =~ s/\.$//;
        $$frq_ref{"$allwords"}++;
    }
    @$seg = ();
}

1;

__END__

=head1 NAME

    TermExtract::BrillsTagger 
                -- ѸХ⥸塼"Brill's Tagger")

=head1 SYNOPSIS

    use TermExtract::BrillsTagger;

=head1 DESCRIPTION

    ϥƥȤ"Brill's Tagger"ʱʸʻ쥿Ϳץˤˤ
  η̤ȤϥƥȤѸФץࡣ
    Brill's Tagger򸵤ˤƺ줿 Monty Tagger ˤбƤ롣

    ʤBrill's Tagger ǥդԤϡBrill's Tagger
  °Perlץ Tokenizer.pl 򤫤ƤȤ侩Ƥ롣

    ⥸塼λˡˤĤƤϡƥ饹TermExtract::Calc_Imp)
  ʲΥץ륹ץȤ򻲾ȤΤȡ

=head2 Sample Script

 #!/usr/local/bin/perl -w
 
 #
 #  ex_BT.pl
 #
 #ե뤫Brill's Tagger ν̤ɤ߼
 #  ɸϤѸȤν٤֤ץ
 #
 #   version 0.09
 #
 #
 
 use TermExtract::BrillsTagger;
 #use strict;
 my $data = new TermExtract::BrillsTagger;
 my $InputFile = "BT_out.txt";    # ϥե
 
 # ץΰ۾ｪλ
 # (åǥ쥯ȥѤΤߡ
 $SIG{INT} = $SIG{QUIT} = $SIG{TERM} = 'sigexit';
 
 # ϥ⡼ɤ
 # 1  Ѹܽ١2  ѸΤ
 # 3  ޶ڤ
 my $output_mode = 1;
 
 #
 # ɥѸ٤ٷ׻˻Ȥɤ
 # ʥǥեȤϻ $obj->use_frq
 #
 #$data->no_frq;  # ɥѸ٤ٷ׻˻Ȥʤ
 #$data->use_frq; # ɥѸ٤ٷ׻˻Ȥ
 
 #
 # ٷ׻Ϣܸ"ٿ"Ȥ뤫"ۤʤ"Ȥ뤫
 # ʥǥեȤ"ٿ"Ȥ $obj->use_total)
 #
 #$data->use_total; # ٿȤ
 #$data->use_uniq;  # ۤʤȤ
 
 #
 # ٷ׻ǡؽǽȤɤ
 # ʥǥեȤϡѤ $obj->use_stat)
 #
 #$data->use_stat; # ؽǽȤ
 #$data->no_stat;  # ؽǽȤʤ
 
 #
 # ٷ׻ǡ֥ɥѸ١פȡϢܸν١
 # ΤɤŤ򤪤ꤹ롣
 # ǥեͤϣ
 # ͤ礭ۤɡ֥ɥѸ١פŤޤ
 #
 #$data->average_rate(0.5);
 
 #
 # ؽǽDB˥ǡѤ뤫ɤ
 # ٷ׻ǡؽǽȤȤϡåȤƤۤ
 # ̵񡣽оݤ˳ؽǽDBϿƤʤ줬ޤޤ
 # ưʤ
 # ʥǥեȤϡѤ $obj->use_storage
 #
 #$data->use_storage; # Ѥ
 #$data->no_storage;  # Ѥʤ
 
 #
 # ؽǽDB˻ѤDBMSDBM_File˻
 # ʥǥեȤϡDB_FileBTREE⡼ɡ
 #
 #$data->use_SDBM;
 
 #
 # ΥɥȤפȤΥǡ١
 # ե̾򥻥å
 # ʥǥեȤ "stat.db""comb.db"
 #
 #$data->stat_db("stat.db");
 #$data->comb_db("comb.db");
 
 #
 # ǡ١¾åΤΰǥ쥯ȥ
 # ǥ쥯ȥ̾ʸʥǥեȡˤξϥåʤ
 #
 #$data->lock_dir("lock_dir");
 
 #
 # ʻ쥿դѤߤΥƥȤ顢ǡɤ߹
 # ѸꥹȤ֤
 # DBѡɥٻѤ˥åȡ
 #
 #my @noun_list = $data->get_imp_word($str, 'var');     # Ϥѿ
 my @noun_list = $data->get_imp_word($InputFile); # Ϥե
 
 #
 # ɤ߹ʻ쥿դѤߥƥȥե򸵤
 # ⡼ɤѤơѸꥹȤ֤
 #$data->use_stat->no_frq;
 #my @noun_list2 = $data->get_imp_word();
 # ޤη̤̤Υ⡼ɤˤ̤ȳݤ碌
 #@noun_list = $data->result_filter (\@noun_list, \@noun_list2, 30, 1000);
 
 #
 #  ѸꥹȤȷ׻٤ɸϤ˽Ф
 #
 foreach (@noun_list) {
    # ͤΤߤɽʤ
    next if $_->[0] =~ /^\d+$/;
 
   # ɽ
   printf "%-60s %16.2f\n", $_->[0], $_->[1] if $output_mode == 1;
   printf "%s\n",           $_->[0]          if $output_mode == 2;
   printf "%s,",            $_->[0]          if $output_mode == 3;
 }

=head1 Methods

    Υ⥸塼Ǥϡget_imp_word Τ߼ʳΥ᥽åɤϿ
  ⥸塼 TermExtract::Calc_Imp ǼƤ롣
    get_imp_word ʻ쥿ͿԤФ줿ñ򡢸ġñθ
  ʻ򸵤ʣƤ롣ʳΥ᥽åɤˤĤƤϡ
  TermExtract::Calc_Imp PODɥȤ򻲾Ȥ뤳ȡ

=head2 get_imp_word

    ʸʻ쥿Ϳ̤򼡤Υ롼ˤʣ롣裱ϡ
  оݤΥǡ裲裱μ̤Ǥ롣ǥեȤǤϡ裱
  ϡʻ쥿դѤߤΥƥȥեȤʤ롣裲ʸ
  'var'åȤ줿Ȥˤϡʻ쥿դѤΥƥȥǡ
  ä顼ѿȲ᤹롣

    ʻϼΤȤ礹
       ʣ̾(NN)      ̾졢ƻ졢ʬư
                                   礹롣ʣƬˤʤ롣
 ʣ˳(FW)    ñȤƽ
       ʣ˴(CD)      ʣƬΤߵĤ
       ʣ˷ƻ(JJ)    ƻ,ͭʸ,˷礹롣
                                   ʣƬˤʤ
        (˽ͭʸ(POS) ̾˷礹
       ʣof̾˷礹
       ʣ˲ʬư(VBN) ʣƬΤߵĤ

    ԤäϡʣζڤȤ

    εͤǻϤޤξϡʣζڤȤ

        +-%\&\$*#^|

    ʣ̾줫ǽΤȤʸڤΤƤ

    ͭ̾ʳ̾ϡƬʸξ˾ʸѴ

    ʣ̾(NNS)ñѤ

    ' ʥ󥰥륯ơ)Ƕڤ줿ñȤ

    ʣ , . Ͻ

    ٷ׻ˤƼθ̵뤹
      of Of OF

=head1 SEE ALSO

    TermExtract::Calc_Imp
    TermExtract::Chasen
    TermExtract::MeCab
    TermExtract::EnglishPlainText

=head1 COPYRIGHT

    Υץϡء͵ֶ͹Ωءä§
  Ѹ켫ưХƥפtermex_e.pl 򸵤˥⥸塼
  TermExtractѤ˽񤭴ΤǤ롣
    κȤϡءϯ (maeda@lib.u-tokyo.ac.jp)Ԥä

    ʤܥץλѤˤʤ̤˴ؤƤǤ
  Ǥʤ

=cut
