package TermExtract::Calc_Imp;

use strict;
use Fcntl;
use Exporter();
use vars qw(@ISA @EXPORT $VERSION *DB_File_Usable $DB_BTREE $MAX_CMP_SIZE);
# DB_File⥸塼뤬Ѳǽʤ⥸塼ɤ߹
BEGIN {
    if (eval "require DB_File") { 
        DB_File->import;
        *DB_File_Usable = \1; # DB_File⥸塼Ѳ
    }
    else {
        *DB_File_Usable = \0; # DB_File⥸塼Բ
    }
}
$MAX_CMP_SIZE = 1024; # ȾѶڤñ̾ꥹȤκĹ

@ISA = qw(Exporter);
@EXPORT = qw();
$VERSION = "2,05";


# ========================================================================
# new -- constructor ʥ֥Ȥ
# 
# usage: $obj = TermExtract::Calc_Imp->new();
#
# ========================================================================
sub new {
    my $class = shift;
    my $self ={};
    bless $self, $class;
    $self->init();
    $self;
}


# ========================================================================
# init -- to initialize variables (֥ȤΥǥեͤ򥻥å)
#
# usage: $obj->init();
#
# ========================================================================
sub init {
    my $self = shift;
    $self->{'stat_db'}            = "stat.db";   # ñ̾줴ȤϢ׾ѤDB
    $self->{'comb_db'}            = "comb.db";   # иϢܤȤ٤ѤDB
    $self->{'comb_r_db'}          = "comb_r.db"; # comb.dbϢܸդˤΡɬܤǤϤʤ
    $self->{'lock_dir'}           = "";          # DBΥåѥǥ쥯ȥλ
    $self->{'db_locked'}          = 0;           # DBå椫Ͽ 0  åʤ1  å
    $self->{'total_or_uniq'}      = 1;           # Ϣܤ 1  ٿ 0  ۤʤ
    $self->{'frq'}                = 1;           # ʸѸ٤ͭˤ  1 ̵ˤ  0
    $self->{'cmp_noun_list'}      = {};          # ʸѸȤ
    $self->{'average_rate'}       = 1;           # ٷ׻ǤϢܾʸѸ٤ΥХ
    $self->{'stat_mode'}          = 1;           # ٷ׻ǳؽǽ 1  Ȥ 0  Ȥʤ
    $self->{'storage_mode'}       = 1;           # ϢDB˥ǡ 1   0  Ѥʤ
    $self->{'get_word_done'}      = 0;           # ǲϤΥǡ 1   0  ̤
    $self->{'reset_get_word'}     = 0;           # ǲϤΥѥ᡼ʤǤ 1  
    $self->{'sdbm'}               = 0;           # SDBM_File   Ȥ  Ȥʤ
    $self->{'ignore_words'}       = ();          # ٷ׻оݳˤΥꥹȡ
    $self->{'agglutinative_lang'} = 0;           # оݸ줬   졢  
    $self;
}


#================================================================
#
# Calicurate importance of word. Ѹν٤η׻
#
# usage: $obj->get_imp_word(Parameter_1, Parameter_2, ... Parameter_N);
#
#================================================================
sub get_imp_word {
    my $self = shift;
    my @param = @_;
    my $db;

    # get_imp_word Υѥ᡼ get_noun_frq Ϥ
    # ѥ᡼꤬ʤϡå夷ƤǡȤ
    if ((@param != 0)||($self->{'reset_get_word'})) {
        $self->{'cmp_noun_list'} = $self->get_noun_frq (@param);
        if ($self->{'storage_mode'}  & ($DB_File_Usable|$self->{'sdbm'})) {
            # åǥ쥯ȥǤΥåʥץ
            $self->lock_db or die "Now Busy!! Wait a minute" if $self->{'lock_dir'};
            # ϢDB(ؽDBˤ˥ǡ
            eval { $self->storage_stat() }; 
            if ($@) { 
                $self->unlock_db if $self->{'lock_dir'};
                die $@;
            }
            else {
                $self->unlock_db if $self->{'lock_dir'};
            }
        }
        $self->{'reset_get_word'} = 0;
    }
    else {
        unless ($self->{'get_word_done'}) {
            die "Can't calculate importance of word!! Set right parameter at once";
        }
    }
    $self->{'get_word_done'} = 1;

    # ؽǽϢDBˤȤäƤνٷ׻
    if ($self->{'stat_mode'} & ($DB_File_Usable|$self->{'sdbm'})) { 
        $self->lock_db or die "Now Busy!! Wait a minute";  # DBζ򤱤
        eval { $db = $self->calc_imp_by_DB };
        if ($@) {
            $self->unlock_db if $self->{'lock_dir'};
            die $@;
        }
        else {
            $self->unlock_db if $self->{'lock_dir'};
        }
        return @$db;
    }
    # ؽǽϢDBˤȤʤٷ׻
    else {
        unless ($DB_File_Usable|$self->{'sdbm'}) {
            warn "You can use \"no_stat\" mode only\n";
            warn "Install DB_File or set \$self->use_SDBM for use_stat mode\n\n";
        }
        return @{ $self->calc_imp_by_HASH };
    }
}


#================================================================
#
# Get noun frequency [for overwrite]   
# ѸȤ٤ -- ҥ饹ǥС饤Ȥƻ)
#
# Parameters is setted by "get_noun_imp()"
#
# usage: $self->get_noun_frq(@AnyParameters);
#
#================================================================
sub get_noun_frq {}   # 饹ǥС饤ɤ뤿


# ========================================================================
# storage_stat -- storage compound noun to Data Base File
# ϢDB[]Ϣܾѡ
# 
# usage: $self->storage_stat("Input_FileName");
#
# ========================================================================
sub storage_stat {
    my $self       = shift;
    my %stat_db = ();          # ñ̾ñ̤ϢܸDBtieϥå
    my %comb_db = ();          # ϢܤνиDBtieϥå
    my $first_comb = 0;        # Ȥ߹碌ФɤȽե饰

    # DBե򳫤ʣ
    $self->dbopen($self->{'stat_db'}, \%stat_db, O_RDWR|O_CREAT);
    $self->dbopen($self->{'comb_db'}, \%comb_db, O_RDWR|O_CREAT);

    # ʸѸ줴Ȥ˥롼
    while ( my($cmp_noun, $frq) = each %{$self->{'cmp_noun_list'}} ) {
        next if $cmp_noun eq "";                     # ǡʤɤФ
        next if length($cmp_noun) > $MAX_CMP_SIZE;   # ĹãɤФ
        my @org_noun_list  = split(/\s+/, $cmp_noun);         # ñ̾ꥹȤ
        my @noun = ();
        my ($uniq_pre, $total_pre, $uniq_post, $total_post);

        # ᥽å IgnoreWords ǻꤷȿ̵ͤ뤹
        LOOP:
        foreach my $word (@org_noun_list) {
            if ($self->{'ignore_words'}){
                foreach my $ignore (@{ $self->{'ignore_words'} }) {
                    next LOOP if $word eq $ignore;
                }
            }
            next if $word =~ /^[\d\.\,]+$/;
            push @noun, $word;
        }

        if (scalar @noun > 1) {   # ʣξ
            foreach my $i (0 .. $#noun-1) {
                my $comb_key = $noun[$i] . ' ' . $noun[$i+1];   # 2Ĥñ̾Ȥ
                # ʣ줬Фξ
                my $first_comb = 1 unless defined $comb_db{"$comb_key"};

                #
                #  ñ̾줴ȤϢ׾[Pre(N), Post(N)]
                #
                # post word (ˤȤꤦñ̾
                $uniq_pre = $total_pre = $uniq_post = $total_post = 0;
                ($uniq_pre, $total_pre, $uniq_post, $total_post)
                    = split "\t", $stat_db{"$noun[$i]"} if defined $stat_db{"$noun[$i]"};
                $uniq_post   += 1 if $first_comb;
                $total_post  += $frq;
                $stat_db{"$noun[$i]"}
                    = sprintf "%d\t%d\t%d\t%d", $uniq_pre, $total_pre, $uniq_post, $total_post;

                # pre wordˤȤꤦñ̾
                $uniq_pre = $total_pre = $uniq_post = $total_post = 0;
                ($uniq_pre, $total_pre, $uniq_post, $total_post)
                    = split "\t", $stat_db{"$noun[$i+1]"} if defined $stat_db{"$noun[$i+1]"};
                $uniq_pre    += 1 if $first_comb;
                $total_pre   += $frq;
                $stat_db{"$noun[$i+1]"}
                     = sprintf "%d\t%d\t%d\t%d", $uniq_pre, $total_pre, $uniq_post, $total_post;

                # ϢܸȤپ
                if  (defined $comb_db{"$comb_key"}) {
                     $comb_db{"$comb_key"} += $frq;
                }
                else {
                    $comb_db{"$comb_key"} = $frq;
                }
            }
        }
    }
}


#================================================================
#
# Calicurate importance of word by DB. ϢܸDB٤׻
# And return sorted list by importance.
#
# usage: @array = $self->calc_imp_by_DB
#
#================================================================
sub calc_imp_by_DB {
    my $self = shift;
    my %stat_db;      # ñ̾줴ȤϢܸDBtieϥå
    my ($uniq_pre, $total_pre, $uniq_post, $total_post); # DBͤѿ
    my $imp = 1;      # ѸΤν
    my %n_imp;        # Ѹפ򥭡ˡֽͤ١פˤϥå
    my @noun_list;    # ٽѸꥹȡѸȤν١
    my $data_disp;    # Ѹɽѡñ̾ζڤʤˤ˲ù
    my $count = 0;    # 롼ץ󥿡Ѹñ̾򥫥ȡ

    #  average_rate Υå
    if ($self->{'average_rate'} == 0) {
        warn "average_rate is invalid value \n";
        exit(0);
    }

    # ϢܸDB򳫤
    $self->dbopen($self->{'stat_db'}, \%stat_db, O_RDONLY);

    # Ѹ줴Ȥ˥롼
    while ( my($cmp_noun, $frq) = each %{$self->{'cmp_noun_list'}} ) {
        next if $cmp_noun eq "";
        next if length($cmp_noun) > $MAX_CMP_SIZE;
        LOOP:
        foreach my $noun (split /\s+/, $cmp_noun) {
            # ᥽å IgnoreWords ǻꤷȿ̵ͤ뤹
            if ($self->{'ignore_words'}) {
                foreach my $ignore (@{ $self->{'ignore_words'} }) {
                    next LOOP if $noun eq $ignore;
                }
            }
            next if $noun =~ /^[\d\.\,]+$/;
            $uniq_pre = $total_pre = $uniq_post = $total_post = 0;
            ($uniq_pre, $total_pre, $uniq_post, $total_post)
                = split "\t", $stat_db{"$noun"} if defined $stat_db{"$noun"};
            # ϢܸαٿȤ
            if ($self->{'total_or_uniq'}) {
                $imp *= ($total_pre + 1) * ($total_post + 1);
            }
            # ϢܸΰۤʤȤ
            else {
                $imp *= ($uniq_pre + 1) * ($uniq_post + 1);
            }
            $count++;
        }
        $count = 1 if $count == 0;
        # ʿѤǽ٤Ф
        if ($self->{'frq'}) {
            $imp = $imp ** (1 / (2 * $self->{'average_rate'} * $count));   
            $imp = $imp * $frq;
        }
        else {
            $imp = $imp ** (1 / (2 * $count));
        }
        $n_imp{"$cmp_noun"} = $imp;
        $count = 0; $imp = 1;
    }

    # ٤ˤѸꥹȤ򥽡
    # Ѹٽ˥
    if ($self->{'agglutinative_lang'}) {
        foreach my $data ( sort { $n_imp{$b} <=> $n_imp{$a} } keys %n_imp ) {
             $data_disp = modify_agglutinative_lang($data);
             push @noun_list,  [ $data_disp, $n_imp{"$data"} ];
         }
     }
     else {
        foreach my $data ( sort { $n_imp{$b} <=> $n_imp{$a} } keys %n_imp ) {
             push @noun_list,  [ $data, $n_imp{"$data"} ];
        }
    }

    return \@noun_list;
}


#=================================================================
#
# Calicurate importance of word by temporary HASH.
# And return sorted list by importance.
# ʸθΤߤ٤׻٤ǥȤѸꥹ
#   ֤
#
# usage: @array = $self->calc_imp_by_HASH
#
#================================================================
sub calc_imp_by_HASH {
    my $self = shift;
    my $imp = 1;       # ѸΤν
    my %comb;          # ϢܸȤνи
    my %stat;          # ñ̾줴ȤϢܾ
    my %n_imp;         # Ѹפ򥭡ˡֽͤ١פˤϥå
    my @noun_list;     # ٽѸꥹȡѸȤν١
    my $data_disp;     # Ѹɽѡñ̾ڤʤˤ˲ù
    my $count = 0;     # 롼ץ󥿡Ѹñ̾򥫥ȡ

    # Ѹ줴Ȥ˥롼
    foreach my $cmp_noun (keys %{$self->{'cmp_noun_list'}}) {
        next if $cmp_noun eq "";                   # ǡʤɤФ
        next if length($cmp_noun) > $MAX_CMP_SIZE; # ĹãɤФ
        my @org_noun_list = split(/\s+/, $cmp_noun);
        my @noun = ();

        # # ᥽å IgnoreWords ǻꤷȿ̵ͤ뤹
        LOOP:
        foreach my $word (@org_noun_list) {
            if ($self->{'ignore_words'}){
                foreach my $ignore (@{ $self->{'ignore_words'} }) {
                    next LOOP if $word eq $ignore;
                }
            }
            next if $word =~ /^[\d\.\,]+$/;
            push @noun, $word;
        }

        # ʣξ硢Ϣܸξϥå
        if (scalar @noun > 1) {
            foreach my $i (0 .. $#noun-1) {
                my $comb_key = "$noun[$i] $noun[$i+1]";
                my $first_comb = 1 unless defined $comb{"$comb_key"};
                # ϢܸΡɱٿɤȤ
                if ($self->{'total_or_uniq'}) {
                    $stat{$noun[$i]}{'post'}  += $self->{'cmp_noun_list'}{"$cmp_noun"};
                    $stat{$noun[$i+1]}{'pre'} += $self->{'cmp_noun_list'}{"$cmp_noun"};
                }
                # ϢܸΰۤʤȤ
                elsif (defined $first_comb) {
                    $stat{$noun[$i]}{'post'}  += 1;
                    $stat{$noun[$i+1]}{'pre'} += 1;
                }
                else {}
            }
        }
    }

    # Ѹ줴Ȥ˥롼
    foreach my $cmp_noun (keys %{$self->{'cmp_noun_list'}}) {
        next if $cmp_noun =~ /^\s*$/;
        next if length($cmp_noun) > $MAX_CMP_SIZE;
        LOOP:
        foreach my $noun (split(/\s+/, $cmp_noun)){
            # ᥽å IgnoreWords ǻꤷȿ̵ͤ뤹
            if ($self->{'ignore_words'}) {
                foreach my $ignore (@{ $self->{'ignore_words'} }) {
                    next LOOP if $noun eq $ignore;
                }
            }
            next if $noun =~ /^[\d\.\,]+$/;
            my $pre  = $stat{"$noun"}{'pre'}  || 0;
            my $post = $stat{"$noun"}{'post'} || 0;
            $imp *= ($pre + 1) * ($post + 1);
            $count++;
        }
        $count = 1 if $count == 0;
        # ʿѤǽ٤Ф
        if ($self->{'frq'}) {
            $imp = $imp ** (1 / (2 * $self->{'average_rate'} * $count));
            $imp = $imp * $self->{'cmp_noun_list'}{"$cmp_noun"};
         }
        else {
            $imp = $imp ** (1 / (2 * $count));
        }
        $n_imp{"$cmp_noun"} = $imp;
        $count = 0; $imp = 1;
    }

    # Ѹٽ˥
    if ($self-{'agglutinative_lang'}) {
        foreach my $data ( sort { $n_imp{$b} <=> $n_imp{$a} } keys %n_imp ) {
             $data_disp = modify_agglutinative_lang($data);
             push @noun_list,  [ $data_disp, $n_imp{"$data"} ];
         }
     }
     else {
        foreach my $data ( sort { $n_imp{$b} <=> $n_imp{$a} } keys %n_imp ) {
             push @noun_list,  [ $data, $n_imp{"$data"} ];
        }
    }

    return \@noun_list;
}


#================================================================
#
# Filtering extract word list by list
# ѸꥹȤ¾ѸꥹȤǥե륿󥰡
#
# usage: $obj->result_filter(\@list_a, \@list_b, $limit_a, $limit_b);
#
#================================================================
sub result_filter {
    my $self    = shift;
    my $imp_a   = shift;           # Ѹꥹ(A)
    my $imp_b   = shift;           # Ѹꥹ(B)
    my $limit_a = shift || 100000; # Ѹꥹ(A)Υե륿󥰤ξ¿
    my $limit_b = shift || 100000; # Ѹꥹ(B)Υե륿󥰤ξ¿
    my %db_exsist;                 # Ѹ줬ФɤȽꤹ뤿Υϥå
    my @result;                    # ե륿󥰷̤Ѹꥹ
    my $counter = 1;               # ե륿󥰾¿Ƚ

    # Ѹꥹ(A)ѤΥϥå˰ܤѤ
    foreach (@$imp_a) {
        $db_exsist{$_->[0]}++;
        last if $counter >= $limit_a;
        $counter++;
    }

    # Ѹꥹ(B)ȺѤΥϥå
    $counter = 1;
    foreach (@$imp_b) {
        if (defined $db_exsist{$_->[0]}) {
            push @result, $_;
        }
        last if $counter >= $limit_b;
        $counter++;
    }

    return @result;
}


#================================================================
#
# Modify extract word list to readable
# ܸʤɤ[ñڤʤ]ʣɽѤ˲ù
#
# usage: modify_agglutinative_lang("some word");
#
#================================================================
sub modify_agglutinative_lang {
    my $data = shift;
    my $data_disp = "";
    my $eng  = 0;
    my $eng_pre = 0;
    foreach my $noun (split /\s+/, $data) {
        if ($noun =~ /^[\x21-\x7E]+$/) { $eng = 1; }  # \x21-\x7EASCII
        else                           { $eng = 0; }
        if ($eng & $eng_pre) { $data_disp .= ' ' . $noun; } # ȤASCIIʤȾѶ
        else                 { $data_disp .=       $noun; } # 嵭ʳʤڤʤϢ
        $eng_pre = $eng;
    }
    return $data_disp;
}


#================================================================
#
# Set Average rate
# ʥɥ٤ݤٷ׻κݤΡ
#   "Ϣܸ""ɥ"ΥХ󥹤򥻥å)
#
# usage: $obj->average_rate($Any_numerical_value);
#
#================================================================
sub average_rate {
    my $self = shift;
    my $rate = shift;
    if (defined $rate) {
        if ($rate =~ /^\d+/ && $rate != 0) {
            $self->{'average_rate'} = $rate;
        }
    }
    else {
        return $self->{'average_rate'};
    }
}


#================================================================
#
# Dump stat data from DB
# ñ̾줴ȤϢܸDBƤϤ)
#
# usage: $obj->dump_stat_db($Any_key_word);
#
#================================================================
sub dump_stat_db {
    my $self = shift;
    my $key  = shift;      # ѥ
    my $mode = shift;      # Ǥдץ⡼
    my %db_hash;
    local (*DB);
    my $db  = $self->dbopen($self->{'stat_db'}, \%db_hash, O_RDONLY);

    if ($key) {
        # SDBM ξϴץ⡼
        if ($mode|$self->{'sdbm'}) {
            print $key, "\t";
            $db_hash{$key} ? print $db_hash{$key} : print join "\t", (0,0,0,0);
            print "\n";
        }
        # Berkeley DB ξץ⡼
        else {
            lmatch($$db, $key);
        }
    }
    else {
        foreach  (keys %db_hash) {
            print $_, "\t", $db_hash{$_}, "\n";
        }
    }
}


#================================================================
#
# Dump combinated word data from DB
# ʣñ̾ȤνиپϤ)
#
# usage: $obj->dump_comb_db([$Any_key_word] [,$bool]);
#
#================================================================
sub dump_comb_db {
    my $self = shift;
    my $key  = shift; # ѥ
    my $mode = shift; # Ǥдץ⡼
    my %db_hash;

    my $db  = $self->dbopen($self->{'comb_db'}, \%db_hash, O_RDONLY);
    if ($key) {
        # SDBM ξϴץ⡼
        if ($mode|$self->{'sdbm'}) {
            print $key, "\t";
            print $db_hash{$key} if $db_hash{$key};
            print "\n";
        }
        # Berkeley DB ξץ⡼
        else {
            lmatch($$db, $key);
        }
    }
    else {
        foreach  (keys %db_hash) {
            print $_, "\t", $db_hash{$_}, "\n";
        }
    }
}


#================================================================
#
# Dump combinated word from DB (reversed)
# ʣñ̾Ȥνиپ --սˤΤ-- Ϥ)
#
# usage: $obj->dump_comb_r_db([$Any_key_word] [,$bool]);
#
#================================================================
sub dump_comb_r_db {
    my $self = shift;
    my $key  = shift; # ѥ
    my $mode = shift; # Ǥдץ⡼
    my %db_hash;

    my $db  = $self->dbopen($self->{'comb_r_db'}, \%db_hash, O_RDONLY);
    if ($key) {
        # SDBM ξϴץ⡼
        if ($mode|$self->{'sdbm'}) {
            print $key, "\t";
            print $db_hash{$key} if $db_hash{$key};
            print "\n";
        }
        # Berkeley DB ξץ⡼
        else {
            lmatch($$db, $key);
        }
    }
    else {
        foreach  (keys %db_hash) {
            print $_, "\t", $db_hash{$_}, "\n";
        }
    }
}


#================================================================
#
# Make combinated word from DB (reversed)
# ϢܸνиپθսˤDB)
#
# usage: $obj->make_comb_r_db();
#
#================================================================
sub make_comb_rev {
    my $self = shift;
    my %comb_db;          # Ϣܸپģ¡
    my %comb_r_db;        # Ϣܸپģ¡ʵս
    my $words     = "";   # 줫ʤϢܸ
    my $words_r   = "";   # $word սˤ
    my $word_pre  = "";   # 줫ʤϢܸθ
    my $word_post = "";   # 줫ʤϢܸθθ

    # ϢܸDBȤεսѤDB򳫤
    $self->dbopen($self->{'comb_db'},   \%comb_db,   O_RDONLY);
    $self->dbopen($self->{'comb_r_db'}, \%comb_r_db, O_RDWR|O_CREAT);

    # ϢܸDBεս
    undef %comb_r_db;
    foreach  $words (keys %comb_db) {
        ($word_pre, $word_post) = split /\s+/, $words;
        $words_r = "$word_post $word_pre";
        $comb_r_db{$words_r} = $comb_db{$words};
    }
}


#================================================================
#
# Set file name of "stat_db"
# (ñ̾줴ȤΡϢܸDBΥե̾򥻥åȡ
#
# usage: $obj->stat_db("AnyFileName");
#
#================================================================
sub stat_db {
    my $self = shift;
    if (defined $_[0] && $_[0] =~ /^[\.]*[\/]*$/) 
           { die "Iregurar name for DB File Name $_[0]\n"; }
    defined $_[0]
        ? $self->{'stat_db'} = $_[0]
        : return $self->{'stat_db'};
}


#================================================================
#
# Set file name of "comb_db"
# (ϢܸDBΥե̾򥻥åȡ
#
# usage: $obj->comb_db("AnyFileName");
#
#================================================================
sub comb_db {
    my $self = shift;
    if (defined $_[0] && $_[0] =~ /^[\.]*[\/]*$/) 
           { die "Iregurar name for DB File $_[0]\n"; }
    defined $_[0]
        ? $self->{'comb_db'} = $_[0]
        : return $self->{'comb_db'};
}


#================================================================
#
# Set file name of "comb_r_db"
# ("ս"ϢܸDBΥե̾򥻥åȡ
#
# usage: $obj->comb_r_db("AnyFileName");
#
#================================================================
sub comb_r_db {
    my $self = shift;
    if (defined $_[0] && $_[0] =~ /^[\.]*[\/]*$/) 
           { die "Iregurar name for DB File $_[0]\n"; }
    defined $_[0]
        ? $self->{'comb_r_db'} = $_[0]
        : return $self->{'comb_r_db'};
}


#================================================================
#
# Clear data from DB
# (ؽѣģ¤Υǡ򥯥ꥢ)
#
# usage: $obj->clear_db;
#
#================================================================
sub clear_db {
    my $self = shift;
    my %stat_db = ();          # ñ̾ñ̤ϢܸDBtieϥå
    my %comb_db = ();          # ϢܤνиDBtieϥå
    $self->dbopen($self->{'stat_db'}, \%stat_db, O_RDWR|O_CREAT);
    $self->dbopen($self->{'comb_db'}, \%comb_db, O_RDWR|O_CREAT);
    %stat_db = ();
    %comb_db = ();
}


#================================================================
#
# Open DBM
# (DBMΥץ)
#
# usage: $obj->dbopen($db_filename, \%hash_for_tie, $mode);
#
#================================================================
sub dbopen {
    my $self  = shift;
    my $file  = shift;       # DBΥե̾
    my $hash  = shift;       # DBtie뤿Υϥåե
    my $mode  = shift;       # FnctlΥե륪ץΥ⡼

    # Berkeley DB ξ
    unless ($self->{'sdbm'}) {
        my $db = tie (%$hash, 'DB_File', $file, $mode, '0644', $DB_BTREE)
            || die "Can not open DB_File $file\n";
        return \$db;
    }
    # SDBM ξ
    else {
       tie (%$hash, 'SDBM_File', $file, $mode, '0644')
            || die "Can not open SDBM_File $file\n";
       return 1;
    }
}


#================================================================
#
# Use SDBM insted of Berkeley DB
# (ؽDBSDBMȤ
#
# usage: $obj->use_SDBM;
#
#================================================================
sub use_SDBM {
    my $self = shift;
    use SDBM_File;
    $self->{'sdbm'} = 1;
    $self;
}


#================================================================
#
# Set directory name of "lock_dir"
# ϢܸDBΥå˥ե饰̤ǥ쥯ȥ̾򥻥åȡ
#
# usage: $obj->lock_dir("AnyDirName");
#
#================================================================
sub lock_dir {
    my $self = shift;
    if (defined $_[0] && $_[0] =~ /^[\.]*[\/]*$/) 
           { die "Iregurar name for lock directory $_[0]\n"; }
    defined $_[0]
        ? $self->{'lock_dir'} = $_[0]
        : return $self->{'lock_dir'};
}


#================================================================
#
# Set calcurate mode to "use_total"
# ʽٷ׻ǡϢܸ٤Ȥ⡼ɤ˥åȡ
#
# usage: $obj->use_total;
#
#================================================================
sub use_total {
    my $self = shift;
    $self->{'total_or_uniq'} = 1;
    $self;
}


#================================================================
#
# Set calcutate mode to "use_uniq"
# ʽٷ׻ǡϢܸαٿȤ⡼ɤ˥åȡ
#
# usage: $obj->use_uniq;
#
#================================================================
sub use_uniq {
    my $self = shift;
    $self->{'total_or_uniq'} = 0;
    $self;
}


#================================================================
#
# Set calcuttate mode to "use_frq"
# (ٷ׻ǡɥȾѸ٤Ȥ⡼ɤ˥åȡ
#
# usage: $obj->use_frq;
#
#================================================================
sub use_frq {
    my $self = shift;
    $self->{'frq'} = 1;
    $self;
}


#================================================================
#
# Set calcurate mode to "no_frq"
# ʽٷ׻ǡɥȾѸ٤Ȥʤ⡼ɤ˥åȡ
#
# usage: $obj->no_frq;
#
#================================================================
sub no_frq {
    my $self = shift;
    $self->{'frq'} = 0;
    $self;
}


#================================================================
#
# Set calcurate mode to "use_stat_DB"
# ʽٷ׻ǡϢܸDBѤ⡼ɤ˥åȡ
#
# usage: $obj->use_stat;
#
#================================================================
sub use_stat {
    my $self = shift;
    $self->{'stat_mode'} = 1;
    $self;
}


#================================================================
#
# Set calcurate mode to "no_stat"
# ʽٷ׻ǡϢܸDBѤʤ⡼ɤ˥åȡ
#
# usage: $obj->no_stat
#
#================================================================
sub no_stat {
    my $self = shift;
    $self->{'stat_mode'} = 0;
    $self;
}


#================================================================
#
# Set storage mode ON
# (ϢܸDB˥ǡѤ⡼ɤ˥åȡ
#
# usage: $obj->use_storage;
#
#================================================================
sub use_storage {
    my $self = shift;
    $self->{'storage_mode'} = 1;
}


#================================================================
#
# Set storage mode OFF
# (ϢܸDB˥ǡѤʤ⡼ɤ˥åȡ
#
# usage: $obj->no_storage;
#
#================================================================
sub no_storage {
    my $self = shift;
    $self->{'storage_mode'} = 0;
}


#================================================================
#
# set Ignore words
# ʥɥ٤ݤٷ׻κݤΡ
#   "Ϣܸ""ɥ"ΥХ󥹤򥻥å)
#
# usage: $obj->average_rate($Any_numerical_value);
#
#================================================================
sub IgnoreWords {
    my $self  = shift;
    my @words = @_;
    if (@words) {
        $self->{'ignore_words'} = \@words;
    }
    else {
        return @{ $self->{'ignore_words'} };
    }
}


#================================================================
#
# Set language type to agglutinative language
# (оݸ[ܸ졢ʤɤñڤΤʤ]˥åȡ
#
# usage: $obj->IsAgglutinativeLang;
#
#================================================================
sub IsAgglutinativeLang {
    my $self = shift;
    $self->{'agglutinative_lang'} = 1;
}


#================================================================
#
# Set language type to not agglutinative language
# (оݸ[ե٥åȤʤñڤ]˥åȡ
#
# usage: $obj->NotAgglutinativeLang;
#
#================================================================
sub NotAgglutinativeLang {
    my $self = shift;
    $self->{'agglutinative_lang'} = 0;
}


#================================================================
#
# Reset "get_noun_imp()" result
# (ؿ get_noun_imp Υǡټ˻ѡ
#  get_noun_imp ѥ᡼򲿤Ȥʤ߷פξΤߡ
#
# usage: $obj->reset_get_word;
#
#================================================================
sub reset_get_word {
    my $self = shift;
    $self->{'reset_get_word'} = 1;
    $self;
}


#================================================================
#
# Lock DB File
# (DBζ򤱤뤿Υååǥ쥯ȥǹԤ)
#
#  usage: $obj->lock_db;
#
#================================================================
sub lock_db {
    my $self = shift;
    my $lockdir = $self->{'lock_dir'}; # åǥ쥯ȥ
    if ($lockdir) {
        my $retry = 5; # åΥȥ饤
        while (!mkdir($lockdir, 0755)) {
            if (--$retry <= 0) { return 0; }
            sleep(1);
        }
    }
    $self->{'db_locked'} = 1;
    return 1;
}


#================================================================
#
# Un-Lock DB File
# (DBζ򤱤뤿Υåǥ쥯ȥΥåϤ)
#
#  usage: $obj->unlock_db;
#
#================================================================
sub unlock_db {
    my $self = shift;
    my $lockdir = $self->{'lock_dir'}; # åǥ쥯ȥ
    if ($self->{'db_locked'}) {
        # åǥ쥯ȥñ˺
        rmdir($lockdir) if -e $lockdir;
    }
    $self->{'db_locked'} = 0;
}


#================================================================
#
# Return DB is locked
# (DBå椫ɤ֤)
#
#  usage: $obj->db_locked;
#
#================================================================
sub db_locked {
    my $self = shift;
    # 0  åʤ1  å
    return $self->{'db_locked'};
}


#================================================================
#
# Get key & value from Berkeley DB
# (Berkeley DB饭פͤФ
#
# usage: lmatch(\%db, "Any_Key_word");
#
#================================================================
sub lmatch {
    my $db    = shift;                # tie( %hash, "DB_File ) ֤
    my $key   = shift;                # ץޥå󥰤
    my $okey  = $key;
    my $value = "";
    my $opt   = DB_File::R_CURSOR(); # ׻ꥪץ
    my $hash  = {};
    while ( 1 ) {
        # ܤΤߡפ $key, $value Ф
        # ܰʹߡڤμ $key, $value Ф
        # ֤ͤξ硢ģ¤ʤΤǽλ
        $db->seq( $key, $value, $opt ) and last;

        # ˥פƤ뤫ǧ
        last unless ( $key =~ /^\Q$okey\E(.*)$/s );

        print $key, "\t", $value, "\n";

        $opt = DB_File::R_NEXT();   # ΥФץ
    }
}

1;

__END__

=head1 NAME

    TermExtract::Calc_Imp -- Ѹ׸׻⥸塼

=head1 SYNOPSIS

    use TermExtract::Calc_Imp;

=head1 DESCRIPTION

    TermExtract ϥƥȥǡ顢ѸФPerl⥸
  Ǥ롣
    䦡ספʤɤηǲϥեȤ"Brill's Tagger"ʤɤα
  ʸʻ쥿դեȤν̤⤷ϱʸΤΤϤȤʣ
 ʤ⤷ñˤȡν٤η׻Ƚٽ¤ؤԤ
    䦡פʤɤʣϡCalc_Impλҥ饹
  ᥽å get_imp_word ǽCalc_ImpΤѸν٤η׻Ƚ
  ٽΥꥹȤΤߤԤˤꡢҥ饹򿷵Ѱդ뤳
  ǡ¿ηǲϥեؤбǽˤƤ롣ޤΤΥ
塼ϤȤʤɤˤ餺ư롣

    ٷ׻ϡΤȤԤ

    Υ⥸塼ǤѸϡñ줽ΤΤʣñȤ߹碌
  ƺ롣ʣǾñ̤̾äˡñ̾פȸƤ֡
  ñ̾줬¾ñ̾Ϣ뤷ʣʤȤ¿ۤɡפʳǰ
  ɽȹͤ롣
  ñǡ־ʳصѡפͤƤߤ롣θϡΤȤꣳĤ
  ñ̾ʬǤ롣κݡ줾ñ̾줬¾ñ̾Ȥɤ
  ĤŪˤ狼äƤȤ롣

   ñ̾졡θϢ뤷θϢ뤷
   --------------------------------------------------------
  ־ס
  ֲʳءס
  ֵѡס

    ʣΤν٤ϤΣġñ̾ˤοͤʿѤ
  롣Υ⥸塼ǤʿѤʿѤǤȤ褦ˤ
  ΤˤʿѤȤݡñ̾򰷤ط飱ûͤ
    ʿѤѤ

    ҤΤȤꡢCalc_Impϻҥ饹ǥ᥽å get_noun_frq 򥪡С
  ɤ뤳Ȥư롣
    Υ᥽å get_noun_frq ϻͤϼΤȤꡣ

    
        裱 ----  ֥
        裲ʲǤդǽ

    
        Υͤʤϥåե󥹤֤

          ----  ñ̾ȾѥڡǶڤɽʣ
                  㡡"Ҷ  ǥ"

            ----  ʸΥʣˤνи

      ʤξ¥ϣ˥ХȤȤʾξϰ۾Ȥ
    ʤ̵뤹褦ˤ

      ޤܸΤ褦ñ̾줬ɽʤ
    ξˤϡget_noun_frqǼΥ᥽åɤ¹Ԥ뤳ȡˤꡢ
    ե٥åȰʳñ̾ϣʤǷ̽Ϥ롣
    (Calc_Imp.pm ver.2.00 ξ꤬ɬפˤʤä

         $obj->IsAgglutinativeLang;                    ($objϥ֥)

      ޤΥ᥽åɤȤٷ׻Ԥʤ"of"Τ褦¾θ
    ¿Ȥ߹碌ǤƤޤˤϿ뤳ȤǤ롣
         $obj->IgnoreWords('ñ', 'ñ' ...);  ($objϥ֥)

      (Calc_Imp.pm  ver.1.xx Ǥ @TermExtract::Calc_Imp::IgnoreWords
       ǻꤷƤver.2.00 嵭ѹ

      ХȤοͤϽٷ׻оݤ鳰ñ̤򼨤ν٤
    ʤꤹ뤳Ȥɤˡ
      Хȿͤȡ$obj->IgnoreWords θ줬ñǸ줿ϡϢ
    ˣȤ뤬ѸФϹԤ


=head1 INSTALL

    Υ⥸塼ϡPerl DB_File ⥸塼ʥС졼DBˤλѤ
  侩Ƥ롣⤷DB_FileȤʤϡSDBM_File Ȥ褦
  ($obj->use_SDBM) Ǥ뤬ñ̾ϢDBʳؽǽDBˤʸ
  ɽɽ׸εǽϻȤʤ
    С 5 PerlJPerlޤ)ư롣

=head1 METHODS

    ʲΥ᥽åɤѲǽǤ

=head2 new

    󥹥ȥ饯᥽åɡ
     ExTerm::Calc_Imp ʤ饹ˤΥ֥Ȥ
  Υ֥Ȥ֤

    usage : 

        $obj = TermExtract::AnyClass->new;

             TermExtract::AnyClass饹

=head2 get_imp_word

    Ѹν٤׻ѸȽ١ʿ͡ˤΣǤʤ
  ٤ι⤤֤
  ʥѥ᡼άϡϤȤ٤η׻⡼ɤϤΤĤ
  åȲǽ

    usage :

        @result = $obj->get_imp_word(Parameter_1, Parameter_2, ... Parameter_N);
        foreach (@result) {
            print $_->[0], "\t";    # Ѹ
            print $_->[1], "\n":    # Ѹν
        }

=head2 use_total

    ٷ׻ˤơϢܸνŤߤϢܤñαٿǷ׻롣
  㤨Сץǡǡ־פȤ줬ֲʳءפˣ󡢡ֵѡ
  ˣϢܤȤȡϢܸνŤߤϼΤȤ׻롣

     ʡֲʳءף󡡡ܡֵѡף

      ΤˤʿѤȤݡñ̾򰷤ط飱û
        ͤѤ

    usage :

        $obj->use_total

=head2 use_uniq

    ٷ׻ˤơʣνŤߤñμǤȤ⡼ɤˤ롣
  㤨Сץǡǡ־פȤ줬ֲʳءפˣ󡢡ֵѡ
  ˣϢܤȤȡʣνŤߤϼΤȤ׻롣

     ʡֲʳءסܡֵѡפΣ

      ΤˤʿѤȤݡñ̾򰷤ط飱û
        ͤѤ

    usage :

        $obj->use_uniq

=head2 use_frq

    ٷ׻ˤơɥѸνи٤ݤ⡼
  ˤ롣
    ǥեȤϤΥ⡼ɡ

    usage :

        $obj->use_frq

=head2 no_frq

    ٷ׻ˤơʣϢܾΤߤǷ׻ʥɥ
  ٤νи٤θʤ˥⡼ɤˤ롣

    usage :

        $obj->no_frq;


=head2 use_stat

    ٷ׻ˤơؽǽñ̾줴ȤϢDBξˤȤ
  ɤˤ롣
    ٷ׻ˤơñ̾ϢܾϡȤʤǡ¿ۤ
  ץǡȿ¬롣γؽǽϡޤޤǤ˽о
  ȤƥȤñ̾ϢܾѤٷ׻ѤΤǤ
  롣
     ǥեȤϤΥ⡼ɡPerlDBMȤʤĶǤϡưŪ
  ˳ؽǽOFFˤʤ롣
    ɥȤñ̾ϢܾDBؤɲäϥ⡼ɤˤ餺Ԥ

    usage :

        $obj->use_stat;

=head2 no_stat

    ٷ׻ˤơɥξΤ߻ѡʳؽǽȤʤ
  ˥⡼ɤˤ롣use_stat ᥽åɤι򻲾ȡ

    usage :

        $obj->no_stat;

=head2 agverage_rate

    ٷ׻ǡ֥ɥѸ١פȡñ̾Ϣܲ
  ʿѡפΥХ󥹤Ĵ뤿Υ᥽åɡ
    ٷ׻ǥɥȤ٤Ѥ⡼ɡʥǥեȡˤˤ
  ȤΤߡư롣
    ǥեȤͤϣͰʳ 0 ϼդʤ

    ͤ礭Ȥ롡ɥѸ٤Ťޤ
    ͤ򾮤Ȥ  ñ̾Ϣܲν٤Ťޤ

    usage :

        $obj->average_rate($Any_numeric_value);

=head2 reset_get_word

    "get_imp_word"ååɤϡʤξ硢ǡκɤ߹ߤԤ
  ʤ
    Υ᥽åɤϤŪ˺ɤ߹ߤ򤵤뤿εǽǤ롣
  饹ǥ᥽å get_noun_word  Ȥ餺Ȥư褦߷פƤ
  Τ̣߰ġ

    usage :

        $obj->reset_get_word;

    sample :

        @result1 = $obj->get_imp_word();

        # ١get_imp_word μˤäơǡ
        $obj->reset_get_word;
        @result2 = $obj->get_imp_word();

=head2 result_filter

    "get_imp_word"͡ƱΤγݤ碌Ԥ
    ͤ get_imp_word ͤƱˤʤ롣
    ååɤΥѥ᡼ˡϼΤȤꡣ

      裱   -----   Ѹꥹȣ
      裲   -----   Ѹꥹȣ
      裳   -----   Ѹꥹȣ ξ̲ޤǻѤ뤫
      裴   -----   Ѹꥹȣ ξ̲ޤǻѤ뤫

        裳裴Ͼάġάϡ줾
          "100000"ʼ¼̵¡ˤåȤ롣

    usage :

        @list = $obj->result_filter(\@list_a, \@list_b, $limit_a, $limit_b);

    sample :

        $obj->use_stat;
        @result1 = $obj->get_imp_word();

        $obj->no_stat;
        @result2 = $obj->get_imp_word();

        @result3 = $self->result_filter(\@result1, \@result2, 30, 30);

=head2 stat_db

    ñ̾줴ȤϢܾѤDBե̾ꤹ롣
    ǥեȤ stat.db
    ʤǸƤӽФϡꤵƤDBե֤̾

    usage :

        $obj->stat_db("AnyFileName");

=head2 comb_db

    ñ̾ȤȤνи١ʱٿȰۤʤˤѤDBե
  ̾ꤹ롣
    ǥեȤ comb.db
    ʤǸƤӽФϡꤵƤDBե֤̾

    usage :

        $obj->comb_db("AnyFileName");

=head2 comb_r_db

    ñ̾ȤȤ٤ѤDBե뤫顢ñ̾
  դˤDBݤΡե̾ꤹ롣
    ñ̾׾Ϥ뤿˻ѤΤǡɬܤǤϤʤ
  DBϥ᥽å make_comb_rev ȤȤǽƺ롣
    ǥեȤ comb_r.db
    ʤǸƤӽФϡꤵƤDBե֤̾

    usege :

        $obj->comb_r_db("AnyFileName");


=head2 use_storage

    ñ̾ϢܾDBإǡѤԤ⡼ɤˤ롣ǥեȤϤΥ
  ɡ

    usage :

        $obj->use_storage;

=head2 no_storage

    ñ̾ϢDBؤΥǡѤԤʤ⡼ɤˤ롣
    ٷ׻ǡؽǽȤȤϡΥ⡼ɤˤʤ̵ۤ
    оݤDBϿƤʤ줬ޤޤƤưʤ

    usage :

        $obj->no_storage;


=head2 use_SDBM

    ñ̾ϢDBΥǥեȤBerkeley DBSDBMѹ
  롣
    (Berkeley DBϴĶˤäƤϻȤʤSDBM Ͼ˻Ѳǽ)

    usage :

        $obj->use_SDBM;


=head2 lock_dir

    Υ⥸塼Ǥϡñ̾ϢDBݤĤΥåѥ
  쥯ȥѤƤ롣
    Υ᥽åɤϡΥåѥǥ쥯ȥΥǥ쥯ȥ̾ꤹ롣
    ʸNull͡ˤ򥻥åȤϡåʤ
    ǥեȤǤϡʸ򥻥åȡäƥåϹԤʤ
    ʤǸƤӽФϡꤵƤǥ쥯ȥ֤̾
    ץΰ۾ｪλˤϥå褦ˤʤäƤ뤬ץ
  ζߤκݤˤϡǰåѥǥ쥯ȥ꤬ĤäƤޤǽ
  롣桼ץ¦ǼΤ褦ʥǥ󥰤򤹤뤳Ȥǡץ
  λü 'ctrl' + 'C'ˤˤбǤ롣


      =====================================================

      # ץΰ۾ｪλ
      $SIG{INT} = $SIG{QUIT} = $SIG{TERM} = 'sigexit';

           Any Code ................

      # ץΰ۾ｪλDBΥå
      sub sigexit {
         $obj->unlock_db;
      }

     =======================================================


    ǤåĤǽ롣κݤϡOSåǥ쥯ȥ
  뤳ȡ

    usage :

        $obj->lock_dir("AnyDirName");

=head2 lock_db

    ñ̾ϢDBåʥåѥǥ쥯ȥˡ
    DBåƤϡ1ƥä5ޤǥå
  롣Ǥ⡢å줿ޤޤξϡͤȤ 0 ֤
åϡͤȤ 1 ֤
    ʤΥ᥽åɤϥ᥽å lock_dir ͤåȤ줿Τư
  롣

    usage :

        $obj->lock_db;


=head2 unlock_db

    ñ̾ϢDBΥåʥåѥǥ쥯ȥκˡ

    usage :

        $obj->unlock_db;


=head2 db_locked

    ñ̾ϢDBåɤ֤
    åƤʤ鿿(1)֤

    usage :

        $obj->db_locked;


=head2 dump_stat_db

    ñ̾ϢDBƤɸϤ˽Ф
      ˰ʤξ硢Ϥ
      裱ξ硢ΰץǡϤ
      裲ξ硢裱δץǡϤ
    ʤϥեޥåȤϼΤȤꡣ

        ñ̾[]ͣ[]ͣ[]ͣ[]ͣ

          ͣ -- ñ̾ˤĤθȤ뤫ʰۤʤ
          ͣ -- ʱٿ
          ͣ -- ñ̾θˤĤθȤ뤫ʰۤʤ
          ͣ -- ʱٿ

    usage :

        $obj->dump_stat_db($Any_key_word);

=head2 dump_comb_db

    ФϢܸȤ٤򤪤DBƤɽ롣
      ˰ʤξ硢Ϥ
      裱ξ硢ΰץǡϤ
      裲ξ硢裱δץǡϤ
    ʤϥեޥåȤϼΤȤꡣ

        ñ̾죱[]ñ̾죲[]ñ̾Ȥ߹碌αٿ

    usage :

        $obj->dump_comb_db($Any_key_word);

=head2 dump_comb_r_db

    ФΣñ̾ȤȤνи٤򤪤DBʵսˤ
  ɽ롣
      ˰ʤξ硢Ϥ
      裱ξ硢ΰץǡϤ
      裲ξ硢裱δץǡϤ
    ʤϥեޥåȤϼΤȤꡣ

        ñ̾죱[]ñ̾죲[]ñ̾Ȥ߹碌αٿ

    usage :

        $obj->dump_comb_r_db($Any_key_word);

=head2 make_comb_rev

    ФΣñ̾ȤȤνи٤򤪤DBʵսˤʤ⤷
  Ϲˤ롣
    ٷ׻ǤϻѤʤñ̾ˤɤñ̾줬ӤĤ
  ׾뤳ȤǤ롣

    usage :

        $obj->make_comb_rev;


=head2 clear_db

    ñ̾ϢDBȡФΣñ̾ȤȤνи٤򤪤
  DBƤ򥯥ꥢ롣

    usage :

        $obj->clear_db;


=head2 IgnoreWords

      ٤㤤ˤ⤫餺ñϢܤѽФ㤨СѸ
   ofʤɡˤ٤η׻оݳˤ롣
     桼ץǤϤʤ饹ǤλѤΤѰդ
     (BrillsTagger.pm, EnglishPlainText.pm ʤɤǻѤƤ

    usage :

        $obj->IgnoreWords('ñA', 'ñB', ...);

      Ϳʤȡߤ͡ˤ֤


=head2 IsAgglutinativeLang

    ܸʤɤʸñڤʤˤꤹ
  롣桼ץǤϤʤ饹ǤλѤΤѰդ
    Calc_Imp.pm  ver 2.00 ʹߤǤϡоݸ줬ξ硢
  ᥽åɤλѤɬס(Chasen.pm, MeCab.pm ʤɤǻѤƤ
    Υ᥽åɤѤʤȡϤʥǥեȡˤȤư
  ñ̾ȾѥڡǶڤäǤνϤˤʤ롣

    usage :

        $obj->IsAgglutinativeLang;


=head2 NotAgglutinativeLang

    ʱѸʤʸñ줬ڤƤˤ
  롣桼ץǤϤʤ饹ǤλѤΤѰդ
    ǥեȤΤᡢ̾ϻѤɬפϤʤ

    usage :

        $obj->NotAgglutinativeLang;


=head1 SEE ALSO

    TermExtract::Chasen
    TermExtract::MeCab
    TermExtract::EnglishPlainText
    TermExtract::BrillsTagger

=head1 COPYRIGHT

      Υץϡء͵ֶ͹Ωءä§
    Ѹ켫ưХƥפExtract.pm  򻲹ͤˡ
    ζ饳ǥ󥰤ľΤǤ롣
      κȤϡءϯ(maeda@lib.u-tokyo.ac.jp)Ԥä
      κݤΥ󥻥ץȤϼΤȤꡣ

      ǲϥǡμߤޤƥ⥸塼벽¾Υץ
        ؤȤ߹ߤǤ뤳

      ؽǽϢܸ׾DBؤѤȤγѡˤĤ

      ٷ׻ˡڤؤǤ뤳

      ܸѥåƤPerl (Jperl) ǤϤʤꥸʥ
        Perlư뤳

      γݤΤPerlstrict⥸塼ڤperl-wץ
        б뤳

      ؿפˤ롢׸κ롼ȤϤ

      ñ̾ϢܲʿѤȤ뤳ȡExtract.pmϢܲ
        Σ٤ȤƤ
          ʤϥѥ᡼ˤĴǤ롣Extract.pmƱ
        ˤϡ$obj->average_rate(0.5) Ȥ

      ͤǤդθٷ׻оݤϤ褦ˤ뤳

      ¿б뤿ᡢUnicode(UTF-8)ư뤳

      Extract.pm κԤϼΤȤꡣ

        Keisuke Uchima 
        Hirokazu Ohata
        Hiroaki  Yumoto (Email:hir@forest.dnj.ynu.ac.jp)

        ʤܥץλѤˤʤ̤˴ؤƤ
      ǤϰǤʤ

=cut
