package TermExtract::EnglishPlainText;
use TermExtract::Calc_Imp;

use strict;
use Exporter ();
use vars qw(@ISA $VERSION @EXPORT);
use locale;

@ISA = qw(TermExtract::Calc_Imp Exporter);
@EXPORT = qw();
$VERSION = "2.01";


# ========================================================================
# get_noun_frq -- Get noun frequency.
#                 The values of the hash are frequency of the noun.
# ѸȤ٤륵֥롼
#
#  Over-write TermExtract::Calc_Imp::get_noun_frq
#
# ========================================================================

sub get_noun_frq {
    my $self = shift;
    my $data = shift;           # ϥǡ
    my $mode = shift || 0;      # ϥǡե뤫ѿμѥե饰
    my %cmp_noun_list = ();     # ʣپ줿ϥåʴؿ͡
    my @terms = ();
    my @StopWords = ();

    $self->IgnoreWords('of', 'Of', 'OF');  # of Ͻٷ׻Ȥ

    # ȥåץɤʸǻ
    my @StopWordsLC = qw(
        a          about      above     across     after
        again      against    all       almost     alone
        along      already    also      although   always
        amoung     an         and       another    any
        anybody    anyone     anything  anywhere   are
        area       areas      around    as         ask
        asked      asking     asks      at         away
        b          back       backed    backing    backs
        be         because    became    become     becomes
        been       before     began     behind     being
        begins     best       better    between    big
        both       but        by        c          came
        can        cannot     case      cases      certain
        certainly  clear      clearly   come       could
        d          did        differ    different  differently
        do         dose       done      down       downed
        downing    downs      during    e          each
        early      either     end       ended      ending
        every      everydody  everyone  everything everywhere
        f          face       faces     fact       facts
        far        felt       few       find       finds
        first      for        four      from       full
        fully      further    furthered furthering furthers
        g          gave       general   generally  get
        gets       give       given     gives      go
        going      good       goods     got        great
        greater    greatest   group     grouped    grouping
        groups     h          had       has        have
        having     he         her       herself    here
        high       higher     highest   him        himself
        his        how        however   i          if
        important  in         interest  interested interesting
        interests  into       is        it         its
        itself     j          just      k          keep
        keeps      kind       knew      know       known
        knows      l          large     largely    last
        lather     lastest    least     less       let
        lets       like       likely    long       longer
        longest    m          made      make       making
        man        many       may       me         member
        members    mem        might     more       most
        mostly     mr         mrs       much       must
        my         myself     n         necessary  need
        needed     needing    needs     never      new
        newer      newest     next      no         non
        not        nodody     noone     nothing    now
        nowther    number     numbered  numbering  numbers
        o                     off       often      old
        older      oldest     on        once       one
        only       open       opened    opening    opens
        or         order      ordered   ordering   orders
        other      others     our       out        over
        p          part       parted    parting    parts
        per        perhaps    place     places     point
        pointed    pointing   points    possible   present
        presented  presenting presents  problem    problems
        put        puts       q         quite      r
        rather     really     right     room       rooms
        s          said       same      saw        say
        says       second     seconds   see        seem
        seemed     seeming    seems     sees       several
        shall      she        should    show       showed
        showing    shows      side      sides      since
        small      smaller    smallest  so         some
        somebody   someone    something somewhere  state
        states     still      such      sure       t
        take       taken      than      that       the
        their      them       then      there      therefore
        these      they       thing     things     think
        thoughts   three      those     through    thought
        today      together   too       took       toward
        turn       turned     turning   turns      two
        u          under      untill    up         upon
        us         use        uses      used       v
        very       w          want      wanted     wanting
        well       wells      went      were       what
        when       where      whether   which      while
        who        whole      whose     why        will
        with       within     without   work       worked
        working    works      would     x          y
        year       years      yet       you        young
        younger    youngest   your      yours      z
        to         this       it's      that's     what's
        who's      I'm        am        was        largest
        we         can't      couldn't  wouldn't   you're
        you'd      you've     you'll    wasn't     isn't
        aren't     don't      didn't    dosen't    he's
        he'll      she's      she'll    we're      weren't
        I'll       I'd        we'll      I've      it'll
        who's      where's    haven't    hasn't    hadn't
        won't      there's    whoever    whichever whatever
     );

    # ʸΥȥåץɤɲ
    @StopWords = @StopWordsLC;
    # ƬʸʸΥȥåץɤɲáʣʸ
    push @StopWords, (map { !/^[a-z]$/ ? ucfirst : ()} @StopWordsLC);
    # ʸΥȥåץɤɲ
    push @StopWords, (map { uc } @StopWordsLC);

    # Ϥեξ
    if ($mode ne 'var') {
        local($/) = undef;
        open (IN, $data) || die "Can not open input file. $!";
        $data = <IN>;
        close IN;
    }

    foreach my $morph ((split /\n/, $data)) {
        chomp $morph;
        LOOP:
        foreach my $word ((split /\s+/, $morph)) {
            my $is_end = 0;

            $word =~ s/\(//g;
            $word =~ s/\)//g;
            $word =~ s/\[//g;
            $word =~ s/\]//g;
            $word =~ s/\{//g;
            $word =~ s/\}//g;
            $word =~ s/\<//g;
            $word =~ s/\>//g;
            $word =~ s/\"//g;
            $word =~ s/\'//g;
            next if $word eq "";

            if (($word =~ s/[\.\,\?\!:\;]+$//) & ($word !~ /^[A-Z]\.$/)) {
               $is_end = 1;
            }

            foreach my $stop (@StopWords) {
                if ($word eq $stop || $word =~ /^[\-\.\=\#\/\|\&\*\+]+/) {
                    shift @terms if (defined $terms[0] && $terms[0]  =~ /of/i);
                    pop   @terms if (defined $terms[0] && $terms[-1] =~ /of/i);
                    $cmp_noun_list{ join ' ', @terms }++ if defined $terms[0];
                    @terms  = ();
                    next LOOP;
                }
            }
            push @terms, $word;

            if ($is_end) {
                shift @terms if (defined $terms[0] && $terms[0]  =~ /of/i);
                pop   @terms if (defined $terms[0] && $terms[-1] =~ /of/i);
                $cmp_noun_list{ join ' ', @terms }++ if defined $terms[0];
                @terms  = ();
                next LOOP;
            }
        }
        shift @terms if (defined $terms[0] && $terms[0]  =~ /of/i);
        pop   @terms if (defined $terms[0] && $terms[-1] =~ /of/i);
        $cmp_noun_list{ join ' ', @terms }++ if defined $terms[0];
        @terms = ();
    }
    return \%cmp_noun_list;
}

1;

__END__

=head1 NAME

    TermExtract::EnglishPlainText
                -- ѸХ⥸塼ʱʸ)

=head1 SYNOPSIS

    use TermExtract::EnglishPlainText;

=head1 DESCRIPTION

    ʸΥƥȥǡ򤫤餽ΤޤѸФץࡣ

    ⥸塼λˡˤĤƤϡƥ饹TermExtract::Calc_Imp)
  ʲΥץ륹ץȤ򻲾ȤΤȡ

=head2 Sample Script

 #!/usr/local/bin/perl -w
 
 #
 #  ex_EPT.pl
 #
 #  
 #  ɸϤѸȤν٤֤ץ
 #
 #   version 0.05
 #
 #
 
 use TermExtract::EnglishPlainText;
 #use strict;
 my $data = new TermExtract::EnglishPlainText;
 my $InputFile = "EnglishPlainText_out.txt";    # ϥե
 
 # ץΰ۾ｪλ
 # (åǥ쥯ȥѤΤߡ
 $SIG{INT} = $SIG{QUIT} = $SIG{TERM} = 'sigexit';
 
 # ϥ⡼ɤ
 # 1  Ѹܽ١2  ѸΤ
 # 3  ޶ڤ
 my $output_mode = 1;
 
 #
 # ɥѸ٤ٷ׻˻Ȥɤ
 # ʥǥեȤϻ $obj->use_frq
 #
 #$data->no_frq;  # ɥѸ٤ٷ׻˻Ȥʤ
 #$data->use_frq; # ɥѸ٤ٷ׻˻Ȥ
 
 #
 # ٷ׻Ϣܸ"ٿ"Ȥ뤫"ۤʤ"Ȥ뤫
 # ʥǥեȤ"ٿ"Ȥ $obj->use_total)
 #
 #$data->use_total; # ٿȤ
 #$data->use_uniq;  # ۤʤȤ
 
 #
 # ٷ׻ǡؽǽȤɤ
 # ʥǥեȤϡѤ $obj->use_stat)
 #
 #$data->use_stat; # ؽǽȤ
 #$data->no_stat;  # ؽǽȤʤ
 
 #
 # ٷ׻ǡ֥ɥѸ١פȡϢܸν١
 # ΤɤŤ򤪤ꤹ롣
 # ǥեͤϣ
 # ͤ礭ۤɡ֥ɥѸ١פŤޤ
 #
 #$data->average_rate(0.5);
 
 #
 # ؽǽDB˥ǡѤ뤫ɤ
 # ٷ׻ǡؽǽȤȤϡåȤƤۤ
 # ̵񡣽оݤ˳ؽǽDBϿƤʤ줬ޤޤ
 # ưʤ
 # ʥǥեȤϡѤ $obj->use_storage
 #
 #$data->use_storage; # Ѥ
 #$data->no_storage;  # Ѥʤ
 
 #
 # ؽǽDB˻ѤDBMSDBM_File˻
 # ʥǥեȤϡDB_FileBTREE⡼ɡ
 #
 #$data->use_SDBM;
 
 #
 # ΥɥȤפȤΥǡ١
 # ե̾򥻥å
 # ʥǥեȤ "stat.db""comb.db"
 #
 #$data->stat_db("stat.db");
 #$data->comb_db("comb.db");
 
 #
 # ǡ١¾åΤΰǥ쥯ȥ
 # ǥ쥯ȥ̾ʸʥǥեȡˤξϥåʤ
 #
 #$data->lock_dir("lock_dir");
 
 #
 # ʻ쥿դѤߤΥƥȤ顢ǡɤ߹
 # ѸꥹȤ֤
 # DBѡɥٻѤ˥åȡ
 #
 #my @noun_list = $data->get_imp_word($str, 'var');     # Ϥѿ
 my @noun_list = $data->get_imp_word($InputFile); # Ϥե
 
 #
 # ɤ߹ʻ쥿դѤߥƥȥե򸵤
 # ⡼ɤѤơѸꥹȤ֤
 #$data->use_stat->no_frq;
 #my @noun_list2 = $data->get_imp_word();
 # ޤη̤̤Υ⡼ɤˤ̤ȳݤ碌
 #@noun_list = $data->result_filter (\@noun_list, \@noun_list2, 30, 1000);
 
 #
 #  ѸꥹȤȷ׻٤ɸϤ˽Ф
 #
 foreach (@noun_list) {
    # ͤΤߤɽʤ
    next if $_->[0] =~ /^\d+$/;
 
   # ɽ$output_mode˱ơͼѹ
   printf "%-60s %16.2f\n", $_->[0], $_->[1] if $output_mode == 1;
   printf "%s\n",           $_->[0]          if $output_mode == 2;
   printf "%s,",            $_->[0]          if $output_mode == 3;
 }

=head1 Methods

    Υ⥸塼Ǥϡget_imp_word Τ߼ʳΥ᥽åɤϿ
  ⥸塼 TermExtract::Calc_Imp ǼƤ롣
    get_imp_word ʻ쥿ͿԤФ줿ñ򡢸ġñθ
  ʻ򸵤ʣƤ롣ʳΥ᥽åɤˤĤƤϡ
  TermExtract::Calc_Imp PODɥȤ򻲾Ȥ뤳ȡ

=head2 get_imp_word

    ʸ򼡤Υ롼ˤʣ롣裱ϡоݤΥǡ
  裲裱μ̤Ǥ롣ǥեȤǤϡ裱ϡʸ
  ΥƥȥեȤʤ롣裲ʸ'var'åȤ줿Ȥˤϡ
  ʸΥƥȥǡä顼ѿȲ᤹롣

    ʸ򼡤ξˤꡢʣʬ䤹
      ˲ԤäϡʣζڤȤ

      ñʸǽϡñʸ
        ñޤǤʣȤ롣ե٥åʸ
        ʸ.   A.ˤξ㳰Ȥ
          .,?!:;

      ˻ꤷȥåץɤиϡʣζڤ
       Ȥ롣ȥåץɤϼʸ򸵤ȤĴä
       ΤǤ

         William B. Frakes, Ricardo Baeza-Yates. 1992. Information 
        retrieval : data structures & algorithms. Upper. Saddle 
        River, N.J. :  Prentice Hall PTR
         (ISBN 0-13-463837-9)

          
            of

          ɲä
              to         this       it's      that's     what's
              who's      I'm        am        was        largest
              we         can't      couldn't  wouldn't   you're
              you'd      you've     you'll    wasn't     isn't
              aren't     don't      didn't    dosen't    he's
              he'll      she's      she'll    we're      weren't
              I'll       I'd        we'll      I've      it'll
              who's      where's    haven't    hasn't    hadn't
              won't      there's    whoever    whichever whatever

      ˼εͤʤʸ󤬽иϡʣ
        ڤȤ
          -.=#/|&*+

    "of" ʣƬ⤷ñˤʤäȤϺ

    ñ˼ΤʸޤޤƤϺ
      ()[]{}<>"'

    ٷ׻ˤƼθ̵뤹
      of Of OF


=head1 SEE ALSO

    TermExtract::Calc_Imp
    TermExtract::Chasen
    TermExtract::MeCab
    TermExtract::BrillsTagger

=head1 COPYRIGHT

    Υץϡء͵ֶαʸѸФΥǥ
򸵤ˡءϯ (maeda@lib.u-tokyo.ac.jp)ΤǤ롣

    ʤܥץλѤˤʤ̤˴ؤƤǤ
  Ǥʤ

=cut
